      PROGRAM PAALMC
      CHARACTER TEXT*80,NOMFIC*40
      DIMENSION R(12),AB(90,12),AS(90,12),EG(90,12),GA(90,12),O(90,12)
     1,SI(90,12),ACC(130),ACS(130),THET(130),AN(130),RES(640)
      OPEN(5,FILE='PAALMC.DAT')
C     ANGULAR STEP IS 10/NTH (DEGREE);IREP:SAMPLE NUMBER
      NTH=10
      ANANG=10./FLOAT(NTH)
C     R1:SAMPLE RADIUS;R2:CONTAINER RADIUS;DELTA:RADIAL STEP (CM)
C     STS:MU SAMPLE;STC MU CONTAINER (CM-1)
41    READ (5,'(A)',ERR=54,END=54)NOMFIC
      OPEN(6,FILE=NOMFIC,STATUS='unknown')
      READ (5,'(A)')TEXT
      WRITE(6,'(A)')TEXT
      WRITE(*,'(3A)')TEXT,' STORED IN ',NOMFIC
      READ (5,'(A)')TEXT
      READ(5,*)R1,R2,STS,STC,TET0
      DELTA=(R2-R1)/10.
      TETF=TET0+129.
      WRITE(*,'(6(A,F7.4))')' R1=',R1,'  R2=',R2,'  DELTA=',DELTA,
     1'  STS=',STS,'  STC=',STC,'  TET0=',TET0
      WRITE(*,'(A)')'      WAIT: 15MN / SPECTRUM '
  42  CONTINUE
      PI=3.1415926
      MR=NINT(R1/DELTA +0.1)
      MMAX=NINT(R2/DELTA +0.1)
      Q=R2/R1
      Q2=Q**2
      R12=R1**2
C COMMON FACTOR IN INTEGRATIONS
      FAK=2./(3.*FLOAT(MR*MR))
      MMIN=MR+1
C COMPUT AS,S+C TERM AND OTHER EXPRESSIONS
        BAK=36.*FLOAT(NTH)
        MAX=NINT((TETF-TET0)/10.*FLOAT(NTH))
      DO 1005 I=1,MAX
      AI=I-1
      THET(I)=TET0*PI/360.+AI*PI/BAK
      IF(THET(I).LE.0.0001)GO TO 1005
      IMMAX=MMAX-MR
      DO 3 M=1,IMMAX
      AM=M+MR
      R(M)=(AM-0.5)*R1/FLOAT(MR)
      RHO=R1/R(M)
      RSQ=R(M)*R(M)
      DO 34 N=1,90
      AN1=N
C COMPU3E OMEGA(N,M)
      O(N,M)=THET(I)-PI*0.5+(AN1-0.5)*PI/90.
      SIN1=SIN(O(N,M))
      SIN12=SIN1*SIN1
      SIN2=SIN(O(N,M)-2.0*THET(I))
      SIN22=SIN2*SIN2
C ALPHA(M,N,2THETA)+BETA(M,N,2 THETA)
      AB(N,M)=SQRT(Q2*R12-RSQ*SIN12)+SQRT(Q2*R12-RSQ*SIN22)
C SIGMA(M,N,2 THETA)
      SI(N,M)=2.0*R(M)*SIN(O(N,M)-THET(I))*SIN(THET(I))
C ALPHA + BETA - SIGMA
      AS(N,M)=AB(N,M)-SI(N,M)
      IF (ABS(SIN1)-RHO) 4,5,5
C NU(M,N,2 THETA)
 4    GA(N,M)=SQRT(R12-RSQ*SIN12)
      GO TO 6
 5    GA(N,M)=0.
 6    IF (ABS(SIN2)-RHO) 7,8,8
C ETA(M,N,2 THETA)
 7    EG(N,M)=SQRT(R12-RSQ*SIN22)+GA(N,M)
      GO TO 35
 8    EG(N,M)=0.
   35 CONTINUE
   34 CONTINUE
 3    CONTINUE
      IF(STC)40,1002,40
40    XM=FLOAT(MR)/COS(THET(I))
      MX=INT(XM)
      IF(XM-FLOAT(MX)-0.5)11,12,12
 12   MX=MX+1
 11   BAC=0.
      BBC=0.
      BBS=0.
      BCC=0.
      BCS=0.
      BAOC=0.
      BBOC=0.
      BBOS=0.
      M=1
 13   M=M+1
      FU=FAK*(1.-1./(2.*FLOAT(M)))/(Q2-1.)
      NMAX=90
      AR=ASIN(R1/R(M))
      UN=FLOAT(NMAX)*(AR+PI*0.5-THET(I))/PI
      NU=UN
      IF(UN-FLOAT(NU)-0.5)32,33,33
 33   NU=NU+1
 32   NU1=NU+1
      DO 14 N=NU1,NMAX
 14   BAC=BAC+FU*EXP(-STC*AS(N,M))
      IF (MX-IMMAX) 15,16,16
 15   IF (M-MX) 16,16,20
16    YM=FLOAT(NMAX)*(AR-PI*0.5+THET(I))/PI
      NM=YM
      IF(YM-FLOAT(NM)-0.5)28,29,29
 29   NM=NM+1
 28   NM1=NM+1
      IF(NM-1)30,31,31
 31   DO 19 N=1,NM
      BCC=BCC+FU*EXP(-STC*(AS(N,M)-2.*EG(N,M)))
 19   BCS=BCS+FU*EXP(-STC*(AS(N,M)-2.*EG(N,M))-STS*2.*EG(N,M))
 30   DO 18 N=NM1,NU
      BBC=BBC+FU*EXP(-STC*(AS(N,M)-2.*GA(N,M)))
 18   BBS=BBS+FU*EXP(-STC*(AS(N,M)-2.*GA(N,M))-STS*2.*GA(N,M))
      IF(M-IMMAX)13,23,23
20    XL=FLOAT(NMAX)*(-AR+PI*0.5-THET(I))/PI
      NL= XL
      IF(XL-FLOAT(NL)-0.5)24,25,25
 25   NL=NL+1
 24   NL1=NL+1
      IF (NL-1) 26,27,27
 27   DO 21 N=1,NL
 21   BAOC=BAOC+FU*EXP(-STC*AS(N,M))
 26   DO 22 N=NL1,NU
      BBOC=BBOC+FU*EXP(-STC*(AS(N,M)-2.*GA(N,M)))
 22   BBOS=BBOS+FU*EXP(-STC*(AS(N,M)-2.*GA(N,M))-STS*2.*GA(N,M))
      IF(M-IMMAX)13,23,23
   23 ACC(I)=BAC+BBC+BCC+BAOC+BBOC
      ACS(I)=BAC+BBS+BCS+BAOC+BBOS
      GO TO 1005
 1002 ACS(I)=1.0
      ACC(I)=1.0
 1005 CONTINUE
        DO 51 I=1,MAX
        AN(I)=1.
        IF(ABS(ACC(I)).GT.0.0000001)AN(I)=ACS(I)/ACC(I)
51      CONTINUE
      DO 53 I1=0,127
      DO 55 I2=1,5
55    RES(5*I1+I2)=(AN(I1+1)*FLOAT(6-I2)+AN(I1+2)*FLOAT(I2-1))/5.
53    CONTINUE
      WRITE (6,'(8F10.8)')(RES(I),I=1,640)
      CLOSE(6)
      GO TO 41
54    CLOSE(5)
      STOP
      END
